package com.example.mobilesession

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ImageView
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import com.example.mobilesession.network.models.GetRooms

class RecAdapter(val context: Context,val list:GetRooms): RecyclerView.Adapter<RecAdapter.MyVh>() {
    class MyVh(itemView: View): RecyclerView.ViewHolder(itemView) {
        val image:ImageView = itemView.findViewById(R.id.image_room)
        val name:TextView = itemView.findViewById(R.id.name_room)
        val text: TextView = itemView.findViewById(R.id.numb_deivce)
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): MyVh {
       val root = LayoutInflater.from(context).inflate(R.layout.rec_adapter,parent,false)
        return MyVh(root)
    }

    override fun onBindViewHolder(holder: MyVh, position: Int) {
        when(list.items[position].type){
            "Kitchen"-> holder.image.setImageResource(R.drawable.ic_kitchen)
            "living room"->holder.image.setImageResource(R.drawable.ic_living)
            "bathroom"-> holder.image.setImageResource(R.drawable.ic_bathroom)
        else -> holder.image.setImageResource(R.drawable.ic_kitchen)
        }
        holder.name.text = list.items[position].name

    }

    override fun getItemCount(): Int {
        return list.items.size
    }
}