package com.example.mobilesession

import android.content.Intent
import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.util.Log
import android.view.View
import android.widget.Toast
import com.example.mobilesession.common.Utils
import com.example.mobilesession.databinding.ActivitySignUpBinding
import com.example.mobilesession.network.RetrofitBuild
import com.example.mobilesession.network.models.Secure
import io.paperdb.Paper
import retrofit2.Call
import retrofit2.Callback
import retrofit2.Response
import java.util.regex.Pattern

class SignUpActivity : AppCompatActivity() {
    private val pattern = "[a-z0-9]{1,100}" +
            "\\@" +
            "[a-z]{1,30}" +
            "\\." +
            "[a-z]{1,10}"


    fun emailValid(text:String):Boolean{
        return Pattern.compile(pattern).matcher(text).matches()
    }
    lateinit var binding: ActivitySignUpBinding
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        binding = ActivitySignUpBinding.inflate(layoutInflater)
        setContentView(binding.root)
        Paper.init(this)

    }

    fun register(view: View) {
        val uuID: String = Paper.book().read("uuId","")!!
        if (binding.emailReg.text.isNotEmpty() && binding.passwordReg.text.isNotEmpty() && binding.nameReg.text.isNotEmpty()){
            if (emailValid(binding.emailReg.text.toString())){
                RetrofitBuild().retrofitBuilder().register(
                    email = binding.emailReg.text.toString(),
                    password = binding.passwordReg.text.toString(),
                    name = binding.nameReg.text.toString(),
                    uuid = uuID
                ).enqueue(object : Callback<Secure>{
                    override fun onResponse(call: Call<Secure>, response: Response<Secure>) {
                        if (response.isSuccessful){
                            val intent = Intent(this@SignUpActivity,SignInActivity::class.java)
                            startActivity(intent)
                        }
                    }

                    override fun onFailure(call: Call<Secure>, t: Throwable) {
                        Log.e("Register error",t.localizedMessage)
                        Toast.makeText(this@SignUpActivity, t.localizedMessage, Toast.LENGTH_SHORT).show()
                    }

                })
            }else{
                Utils.AlertBuild("Error","Email error",this)
            }
        }else{
            Utils.AlertBuild("Error","Empty",this)
        }
    }
    fun back(view: View) {
        val intent = Intent(this,SignInActivity::class.java)
        startActivity(intent)
    }
}