package com.example.mobilesession.ui.home

import android.content.Context
import android.content.Intent
import android.content.SharedPreferences
import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.TextView
import android.widget.Toast
import androidx.fragment.app.Fragment
import androidx.fragment.app.FragmentManager
import androidx.lifecycle.ViewModelProvider
import com.example.mobilesession.MapsActivity
import com.example.mobilesession.RecAdapter
import com.example.mobilesession.addRoomPackage.AddRoomActivity
import com.example.mobilesession.databinding.FragmentHomeBinding
import com.example.mobilesession.network.RetrofitBuild
import com.example.mobilesession.network.models.GetRooms
import io.paperdb.Paper
import retrofit2.Call
import retrofit2.Callback
import retrofit2.Response

class HomeFragment : Fragment() {

    private var _binding: FragmentHomeBinding? = null
    lateinit var sharedPreferences: SharedPreferences
    lateinit var editor: SharedPreferences.Editor
    // This property is only valid between onCreateView and
    // onDestroyView.
    private val binding get() = _binding!!

    override fun onCreateView(
        inflater: LayoutInflater,
        container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View {
        Paper.init(requireContext())
        val uuid =  Paper.book().read("uuId","")
        sharedPreferences = requireContext().getSharedPreferences("main",Context.MODE_PRIVATE)
        editor = sharedPreferences.edit()
        val token = sharedPreferences.getString("token","")
        RetrofitBuild().retrofitBuilder().getRooms(
            token = token.toString(),
            uuid = uuid.toString())
            .enqueue(object : Callback<GetRooms>{
                override fun onResponse(call: Call<GetRooms>, response: Response<GetRooms>) {
                    if (response.isSuccessful){
                    binding.roomRec.adapter = response.body()
                        ?.let { RecAdapter(requireContext(), it) }
                    }
                }

                override fun onFailure(call: Call<GetRooms>, t: Throwable) {
                    Toast.makeText(requireContext(), t.localizedMessage, Toast.LENGTH_SHORT).show()
                }
            })
        _binding = FragmentHomeBinding.inflate(inflater, container, false)
        val root: View = binding.root

        initClick()
        return root
    }

    override fun onDestroyView() {
        super.onDestroyView()
        _binding = null
    }

   fun initClick(){
       binding.addRoom.setOnClickListener {
           val addIntent = Intent(requireContext(),AddRoomActivity::class.java)
           startActivity(addIntent)
       }
       binding.your.setOnClickListener {
           val mapsIntent = Intent(requireContext(),MapsActivity::class.java)
           startActivity(mapsIntent)
       }
   }
}